<?php 
class model_component_forum extends model {
	public function get_topics($data = array()) {
		$sql = "SELECT * FROM forum_topics WHERE 1 ";
		
		if (isset($data['user_id'])) {
			$sql .= "AND user_id = '" . (int)$data['user_id'] . "' ";
		}
		
		if (isset($data['url'])) {
			$sql .= "AND url = '" . $this->dbh->escape($data['url']) . "' ";
		}
		
		if (isset($data['topic_id'])) {
			$sql .= "AND topic_id = '" . (int)$data['topic_id'] . "' ";
		}
		
		if (isset($data['sort'])) {
			$sql .= "ORDER BY " . $this->dbh->escape($data['sort']) . " ";
		}
		
		if (isset($data['limit'])) {
			$sql .= "LIMIT " . $this->dbh->escape($data['limit']) . " ";
		}
		
		return $this->dbh->query($sql);
	}
	
	public function get_topic($data, $type = 'by_id') {
		$topic_data = array('limit' => 1);
		if ($type == 'by_url') {
			$topic_data['url'] = $data;
		} else {
			$topic_data['topic_id'] = $data;
		}
		$results = $this->get_topics($topic_data);
		if ($results) {
			return $results[0];
		} else {
			return array();
		}
	}
	
	public function get_posts($data = array()) {
		$sql = "SELECT * FROM forum_posts WHERE 1 ";
		
		if (isset($data['post_id'])) {
			$sql .= "AND post_id = '" . (int)$data['post_id'] . "' ";
		}
		
		if (isset($data['topic_id'])) {
			$sql .= "AND topic_id = '" . (int)$data['topic_id'] . "' ";
		}
			
		if (isset($data['user_id'])) {
			$sql .= "AND user_id = '" . (int)$data['user_id'] . "' ";
		}
		
		if (isset($data['sort'])) {
			$sql .= "ORDER BY " . $this->dbh->escape($data['sort']) . " ";
		} else {
			$sql .= "ORDER BY id ASC ";
		}
		
		if (isset($data['limit'])) {
			$sql .= "LIMIT " . $this->dbh->escape($data['limit']) . " ";
		}
		
		return $this->dbh->query($sql);
	}
	
	public function get_posts_total($data = array()) {
		$sql = "SELECT COUNT(*) as count FROM forum_posts WHERE ";
		
		if (isset($data['user_id'])) {
			$sql .= "user_id = '" . (int)$data['user_id'] . "'";
		} elseif (isset($data['topic_id'])) {
			$sql .= "topic_id = '" . (int)$data['topic_id'] . "'";
		}
		
		$result = $this->dbh->row($sql);
		
		return (int)$result['count'];
	}
	
	public function get_topics_total($data = array()) {
		$sql = "SELECT COUNT(*) as count FROM forum_topics ";
		
		if (isset($data['user_id'])) {
			$sql .= "WHERE user_id = '" . (int)$data['user_id'] . "'";
		}
		
		$result = $this->dbh->row($sql);
		
		return (int)$result['count'];
	}
	
	public function add_topic($data) {
		$sql = "INSERT INTO forum_topics (name, text, url, user_id, date_add) 
								VALUES (
									'" . $this->dbh->escape($data['name']) . "',
									'" . $this->dbh->escape($data['text']) . "',
									'" . $this->dbh->escape($data['url']) . "',
									'" . (int)$data['user_id'] . "',
									'" . time() . "'
								)";
		$this->dbh->exec($sql);
		return $this->dbh->lastInsertId();
	}
	
	public function add_post($data) {
		$sql = "INSERT INTO forum_posts (topic_id, user_id, text, date_add) 
								VALUES (
									'" . (int)$data['topic_id'] . "',
									'" . (int)$data['user_id'] . "',
									'" . $this->dbh->escape($data['text']) . "',
									'" . time() . "'
								)";
		$this->dbh->exec($sql);
		return $this->dbh->lastInsertId();
	}
}